pub trait Differentiable {
    type Diff;
    fn diff(a: Self, b: Self) -> Self::Diff;
    fn apply(&mut self, d: Self::Diff);
}

pub struct List<T>(Vec<T>);

pub enum ListDiff<T> {
    Insert(usize, T),
    Delete(usize),
    Update(usize, T),
}

impl<T: Differentiable> Differentiable for List<T> {
    type Diff = Vec<(usize, T::Diff)>;

    fn diff(_a: Self, _b: Self) -> Self::Diff {
        todo!()
    }

    fn apply(&mut self, _d: Self::Diff) {

    }
}

pub struct Chow {
    items: Vec<String>,
}

pub struct ChowDiff;

impl Differentiable for Chow {
    type Diff = ChowDiff;
    fn diff(_a: Self, _b: Self) -> Self::Diff {
        todo!()
    }

    fn apply(&mut self, _d: Self::Diff) {

    }
}

pub struct ClientState {
    text: Chow,
    shadow: Chow,
    current_client_version: usize,
    last_server_version: usize,
}

impl ClientState {

}

pub struct ServerState {
    text: Chow,
    shadow: Chow,
    backup_shadow: Chow,
}